// Module Author: Biju G.C. 2003.0625
// License: The Mozilla Public License ( http://www.mozilla.org/MPL/ )
//
// Change Log :
// 2003.08.05 - Biju G.C. 
//   - Modified openCalendarApplication to get menu & status bar
//     for calendar application
//     bug reported (with fix) by Mostafa Hosseini <mostafah@oeone.com> 

var QuickTools ;  // Declare QuickTools object

// Define QuickTools object
// Author: Biju G.C. 2003.0625
QuickTools = function() 
{

  //var xyz = new Function('x','y','return x * y');
  QuickTools = new Function();
  QuickTools.prototype.New = function(){return new this.constructor()};

  var lstAdd    = QuickToolsSettings.addList;
  var lstRemove = QuickToolsSettings.removeList;
  var oPref     = QuickToolsSettings.preferences;
  var oConst    = QuickToolsConst ;

  // Loop to update menus with preferences from profile
  // Author: Biju G.C. 2003.0625
  QuickTools.prototype.updateLoop = function ()
  {
    var oCurrMenu;
    var sCurrItem;

    for(i=0;i < lstAdd.length; i++)
    {
      sCurrItem = lstAdd[i];
      oCurrMenu = document.getElementById(oConst.PREFIX + sCurrItem + oConst.MENUSUFIX);
      if(oCurrMenu && oPref.prefHasUserValue(sCurrItem))
        if(oPref.getIntPref(sCurrItem) == 1) oCurrMenu.removeAttribute("hidden");
        else oCurrMenu.setAttribute("hidden", "true");
    }
  }


  // If not exist intialize/remove entries
  // for preferences in profile
  // Author: Biju G.C.
  QuickTools.prototype.init = function()
  {
    var sCurrItem;
    var i;
    
    for(i=0;i < lstAdd.length; i++)
    {
      sCurrItem = lstAdd[i];
      if(!oPref.prefHasUserValue(sCurrItem) || oPref.getPrefType(sCurrItem) != oConst.PREF_INT)
      {
        oPref.setIntPref(sCurrItem, 1);
      }
    }
    
    for(i=0;i <  lstRemove.length; i++)
    {
      sCurrItem = lstRemove[i];
      if(oPref.prefHasUserValue(sCurrItem))
      {
        oPref.clearUserPref(sCurrItem);
      }
    }
  }


  // Calls preferences settings window 
  // Author: Biju G.C. 2003.0625
  QuickTools.prototype.quicktoolsPreferences = function () 
  {
   try {
     window.openDialog("chrome://quicktools/content/preferences.xul", "",
                       "centerscreen,chrome,dialog=yes,resizable,dependent")
   } catch (e) {alert('error');}
  }

  // Menu event method to open Calendar Application
  // Author: Biju G.C. 2003.0625
  QuickTools.prototype.openCalendarApplication = function () 
  {
   try {
   window.open('chrome://calendar/content/calendar.xul','_blank', 'chrome,toolbar,resizable,menubar,status,extrachrome'); 
   } catch (e) {alert('error');}
  }


  // Menu event method to install a theme from URL 
  // Author: Biju G.C. 2003.0625
  QuickTools.prototype.installFromURLTheme = function (mode, menu)
  {
    var filename = prompt(getPrompt (menu, 'Enter Theme URL'));
    if (filename) installThemeNow(filename);
  }


  // Menu event method to install a extension from URL 
  // Author: Biju G.C. 2003.0625
  QuickTools.prototype.installFromURLExt = function (mode, menu)
  {
    var filename = prompt(getPrompt (menu, 'Enter Extention URL'));
    if (filename) triggerURL(filename);
  }

  // gets prompt attribute from an object 
  // Author: Biju G.C. 2003.0625
  function getPrompt (thisobject, defaultval)
  {
   if(thisobject && thisobject.getAttribute && thisobject.getAttribute("prompt")) 
     return thisobject.getAttribute("prompt");
   else
     return defaultval;
  }

  // Credits to mozdev.org, following function copied from
  // http://mozdev.org
  // Author: unknown
  function triggerURL(url) 
  {
    if (!InstallTrigger.updateEnabled()) return false; 
    else InstallTrigger.startSoftwareUpdate(url); 
  }


  // Credits to David Tenser. & texturizer.net, following 2 function copied
  // from http://texturizer.net/firebird/extensionSetup.js then modified

  // Author: texturizer.net
  function doneFn(name,result) {}

  // Author: texturizer.net
  function doXPIInstall(file,name)
  {
    var xpi = new Object();
    xpi[name] = file;
    InstallTrigger.install(xpi,doneFn);
  }


  // Functions needed for JAR install
  // Author: Alan Starr 20021210
  function installTheme(where)
  {
    var file = '';
    if (where == 'local') {
      file = 'file:///' + escape(document.getElementById('filename').value.replace(/\\/g,'/'));
    } else {
      file = document.getElementById('url').value;
    }
    InstallTrigger.installChrome(InstallTrigger.SKIN, file, getName(file));
  }

  // Finds the name of the theme from the filename
  // Author: Alan Starr 20021210
  function getName(raw)
  {
    var grabFileStart = raw.lastIndexOf('/');
    var grabFileEnd = raw.lastIndexOf('.');
    if (grabFileStart >= grabFileEnd) {
      return 'Invalid file name';
    } else {
      return raw.substring(grabFileStart + 1,grabFileEnd);
    }
  }

  // Author: Alan Starr 20021210
  function installThemeNow(file)
  {
    // used in the hrefs 
    var extStart = file.lastIndexOf('.');
    var fileType = file.substring(extStart, file.length).toLowerCase();
    if (fileType == 'xpi') {
      doXPIInstall(file, getName(file));
    } else {
      InstallTrigger.installChrome(InstallTrigger.SKIN, file, getName(file));
    }
    return true;
  }

  QuickTools = new QuickTools();   // Actual Instance Creation
  QuickTools.init();               // Intialize profile settings

  //Initail menus updates
  window.setTimeout("QuickTools.updateLoop();",  500);
  window.setTimeout("QuickTools.updateLoop();", 1500);

  //Update menus in in a fixed interval
  window.setInterval("QuickTools.init(); QuickTools.updateLoop();", 3000)
}

QuickTools();  // Call for Creating Instance
